//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    MA1Period = 21;
extern int    MA1Method = MODE_EMA;
extern int    MA1Price  = PRICE_CLOSE;
extern int    MA2Period = 8;
extern int    MA2Method = MODE_EMA;

double buffer1[];
double buffer2[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0]=limit; return(0); }
                  if (timeFrame!=Period())
                  {
                     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
                        for(int i=limit; i>=0; i--)
                        {
                           int y = iBarShift(NULL,timeFrame,Time[i]);
                              buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,0,y);
                              buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",MA1Period,MA1Method,MA1Price,MA2Period,MA2Method,1,y);
                        }                              
                        return(0);
                  }

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) buffer1[i] = iMA(NULL,0,MA1Period,0,MA1Method,MA1Price,i);
   for(i=limit; i>=0; i--) buffer2[i] = iMAOnArray(buffer1,0,MA2Period,0,MA2Method,i);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}